#include <iostream>
#include <vector>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin .tie(NULL);
    int n,m;
    cin >>n>>m;
    bool matrix[n][n];
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<n;j++)
        {
            matrix[i][j]=false;
        }
    }

    for(int i=0;i<m;i++)
    {
        int k;
        cin >>k;
        if(k==1)
        {
            int u,v;
            char c;
            cin >>u>>v>>c;
            u--;
            v--;
            matrix[u][v]=true;
            matrix[v][u]=true;
        }
        else
        {
            int u,v;
            cin >>u>>v;
            u--;
            v--;
            if(u=v-1)
            {
                cout <<matrix[u][v]<<"\n";
            }
            else
            {
                cout <<matrix[u][v]<<"\n";
            }
        }
    }


    return 0;
}